#include <math.h>
#include <stdio.h>

class BaseCharacter
{
	public:
		static float jikix, jikiy;
		float x,y;
		bool kill;
		int imageNumber;
		BaseCharacter() {};
		
		virtual void move() = 0;

		void isWindowIn()
		{
			if (x<0 || x>639 || y<0 || y>479)
				kill = true;
		}
};

class Character:	public BaseCharacter
{
	public:
		Character(float getx, float gety)
		{
			kill = false;
			x = getx;
			y = gety;
			imageNumber = 0;
		};
		void move() {};
};

class CBullet:	public BaseCharacter
{
	public:
		float ax, ay, rotate;
		CBullet(float getx, float gety, float getax, float getay)
		{
			x=getx;
			y=gety;
			ax=getax;
			ay=getay;
			kill=false;
			rotate = atan2f(ay-y, ax-x);
		};

		void move()
		{
			x+=(cosf(rotate))*8;
			y+=(sinf(rotate))*8;
			isWindowIn();
		}
};

class CEnemy:	public BaseCharacter
{
	public:
		float count;

		CEnemy(float getx, float gety)
		{
			{
				kill = false;
				x=getx;
				y=gety;
				imageNumber=0;
				count=0;
			};
		}

		void move()
		{
			if ( (count+=.1f) > 6.28)
				count=0;

			x+=(cosf(count)*10);
			y++;
		};
};

class CEnemyStraight:	public BaseCharacter
{
	public:
		float count;
		float speed;

		CEnemyStraight(float getx, float gety)
		{
			{
				kill = false;
				x=getx;
				y=gety;
				imageNumber=0;
				count=0;
				speed=1;
			};
		}

		void move()
		{
			speed+=(speed/20);
			y+=speed;
		};
};

class CEnemySnake:	public BaseCharacter
{
	public:
		CEnemySnake *EnemySnake;
		float rotate;
		float speed;

		CEnemySnake(float getx, float gety, CEnemySnake *getEnemySnake)
		{
			{
				EnemySnake = getEnemySnake;
				kill=false;
				x=getx;
				y=gety;
				imageNumber=0;
				rotate=float(6.28/4*3);
				speed=1;
			};
		}

		void move()
		{
			float ax, ay;
			if (EnemySnake == NULL)
			{
				ax = EnemySnake -> jikix;
				ay = EnemySnake -> jikiy;
				rotate = atan2f(ay-y, ax-x);

				x += (cosf(rotate))*2;
				y += (sinf(rotate))*2;
			}
			else if (EnemySnake -> kill)
			{
				EnemySnake = NULL;
			}
			else 
			{
				ax = EnemySnake -> x;
				ay = EnemySnake -> y;

				rotate = atan2f(ay - y, ax - x);

				if (sqrt( (ay - y) * (ay - y) + (ax - x) * (ax - x) ) > 16)
				{
					x += (cosf(rotate))*2;
					y += (sinf(rotate))*2;
				}
			}
		};
};